#include "W25Q_Platform.h"

#include <avr/io.h>

void W25Q_Init() {
	W25Q_SPI.CTRLB = SPI_SSD_bm;
	W25Q_SPI.CTRLA = SPI_MASTER_bm | SPI_CLK2X_bm | SPI_ENABLE_bm;
	
	W25Q_SPI_SS_PORT.DIRSET = W25Q_SPI_SS_PIN;
	W25Q_SPI_MOSI_PORT.DIRSET = W25Q_SPI_MOSI_PIN;
	W25Q_SPI_SCLK_PORT.DIRSET = W25Q_SPI_SCLK_PIN;
	
	PORTMUX.SPIROUTEA = W25Q_SPI_PORTMUX;
	
	W25Q_DisableSpi();
}

uint8_t W25Q_SendByte(uint8_t byte) {
	W25Q_SPI.DATA = byte;
	while ((W25Q_SPI.INTFLAGS & SPI_IF_bm) == 0);
	return W25Q_SPI.DATA;
}

void W25Q_EnableSpi() {
	W25Q_SPI_SS_PORT.OUTCLR = W25Q_SPI_SS_PIN;
}

void W25Q_DisableSpi() {
	W25Q_SPI_SS_PORT.OUTSET = W25Q_SPI_SS_PIN;
}
