#ifndef W25Q_PLATFORM_H_
#define W25Q_PLATFORM_H_

#include <avr/io.h>

#define W25Q_SPI			SPI0
#define W25Q_SPI_INT_vect	SPI0_INT_vect

#define W25Q_SPI_PORTMUX	PORTMUX_SPI0_ALT6_gc

#define W25Q_SPI_SS_PORT	PORTD
#define W25Q_SPI_SS_PIN		PIN4_bm

#define W25Q_SPI_SCLK_PORT	PORTC
#define W25Q_SPI_SCLK_PIN	PIN3_bm

#define W25Q_SPI_MISO_PORT	PORTC
#define W25Q_SPI_MISO_PIN	PIN2_bm

#define W25Q_SPI_MOSI_PORT	PORTC
#define W25Q_SPI_MOSI_PIN	PIN1_bm


/**
 * Makes hardware intialization of SPI interface to flash memory.
 */
void W25Q_Init();

/**
 * Enables SPI communication and set CS pin to low.
 */
void W25Q_EnableSpi();

/**
 * Disables SPI communication and set CS pin to high.
 */
void W25Q_DisableSpi();

/**
 * Sends one byte over SPI and returns the byte which flash shifted out while transfer.
 */
uint8_t W25Q_SendByte(uint8_t byte);

#endif
